@startuml
title 2i insertGroupStep 
actor Actor
participant "CatERingAppManager.kitchenJobManager:KitchenJobManager" as kjm
participant "kitchenJobManager.currentKitchenJob:KitchenJob" as kj
participant "groupStep: GroupStep" as gs
participant "fatherGroupStep: GroupStep" as fgs
participant "childrens: List<GenericStep>" as gsl
participant "childrensFather: List<GenericStep>" as gslf
participant "r: KitchenJobReceiver" as rec

Actor -> kjm ++:insertGroupStep(alternativeSteps,repetition,fatherGroupStep)

alt currentKitchenJob != null
  kjm -->> Actor:throw UseCaseLogicException
else
  kjm --> kj: insertGroupStep(alternativeSteps,repetition,fatherGroupStep)
  activate kj
  
  kj --> gs **: createGroupStep(alternativeSteps,repetition)
  activate gs
  
  gs -> gs: setAlternativeSteps(alternativeSteps)
  gs -> gs: setRepetitions(repetition)
  gs --> gsl**: create
  gs -->> kj--: groupStep
  kj -> fgs++: addChildren(groupStep)
  fgs -> gslf++: add(groupStep)
  gslf --
  gsl --
  fgs --
  kj -->> kjm--: groupStep
  
  group for each r in receivers
    	kjm -> rec++:notifyGroupStepAdded(currentKitchenJob,groupStep)
        deactivate rec
  end 
    
  kjm -->> Actor--: groupStep
end

@enduml
